#pragma once
#include <windows.h>
#include <string>
#include <vector>

#define SAORI_HEADER	"SAORI/1.0"
#define GET				"GET"
#define VERSION			"Version"
#define EXEC			"EXECUTE"
#define CRLF			"\x0D\x0A"
#define GETVERSION		GET " " VERSION " " SAORI_HEADER
#define EXECUTE			EXEC " " SAORI_HEADER
#define CHARSET			"Charset: UTF-8" CRLF
#define BAD_MES		SAORI_HEADER " 400 Bad Request" CRLF CHARSET CRLF
#define ERR_MES		SAORI_HEADER " 500 Internal Server Error" CRLF CHARSET CRLF
#define NF_MES		SAORI_HEADER " 404 Not Found" CRLF CHARSET CRLF
#define RES_MES_OK	SAORI_HEADER " 200 OK" CRLF
#define RES_MES_NO	SAORI_HEADER " 204 No Content" CRLF

//#define MSGBOX_DEBUG 1

#if defined(_DEBUG) && defined(MSGBOX_DEBUG)
inline void mes_i(size_t i){
	char a[20];
	itoa((int)i,a,10);
	MessageBox(0,a,"",0);
}

inline void mes(const char* a){
	MessageBox(0,a,"",0);
}

inline void mes_w(const wchar_t* a){
	MessageBoxW(0,a,L"",0);
}
#else
#define mes_i(i)
#define mes(a)
#define mes_w(a)
#endif

typedef enum{Local,External} SecurityLevel;
typedef enum {ASCII,SJIS,JIS,EUCJP,UTF8,UTF8N,Unicode} CharSet;

typedef struct{
	std::string cmd_version;
	std::string sender;
	SecurityLevel security_level;
	CharSet charset;
	std::vector<std::string> argument;
} Request;

HGLOBAL set_returnA(std::string mes,long *len);
HGLOBAL set_returnW(std::wstring mes,long *len);
#define set_return set_returnA

void conv_to_multi(const std::wstring &from,std::string &to,CharSet c);
void conv_to_wide(const std::string &from,std::wstring &to,CharSet c);
void conv_multi(const std::string &from,std::string &to,CharSet from_c,CharSet to_c);
UINT codepage(CharSet c);
std::string cp2str(CharSet c);

#include "Imgctl.h"
extern CImgctl *Imgctl;
